<?php

// Pour importer depuis un fichier .csv

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/presentation');
include_spip('inc/auteur_voir');
include_spip('inc/acces');
include_spip('base/abstract_sql');

function exec_auteurs_import_dist()
{
    global $connect_statut, $connect_login, $connect_toutes_rubriques, $couleur_foncee, $flag_gz, $options;

    debut_page("Importation d'une liste d'auteurs", "administration", "base");
 
     // etre admin tu dois
     if ($connect_statut != '0minirezo' ){
        echo _T('avis_non_acces_page');
        fin_page();
        exit;
     }

	echo "<br /><br />";
	gros_titre("Importer des auteurs");
    
    debut_gauche();

    debut_boite_info();
        echo propre("{{Cette page est uniquement accessible aux responsables du site.}}<P> Elle donne acc&egrave;s aux diff&eacute;rentes
        fonctions de maintenance technique. Certaines d'entre elles donnent lieu &agrave; un processus d'authentification sp&eacute;cifique, qui
        exige d'avoir un acc&egrave;s FTP au site Web.");
    fin_boite_info();

    debut_droite();

    debut_cadre_relief();

    echo "<TABLE BORDER=0 CELLSPACING=1 CELLPADDING=8 WIDTH=\"100%\">";
    echo "<TR><TD BGCOLOR='$couleur_foncee' BACKGROUND=''><B>";
    echo "<FONT FACE='Verdana,Arial,Helvetica,sans-serif' SIZE=3 COLOR='#FFFFFF'>";
    echo "Importer un liste d'auteurs</FONT></B></TD></TR>";

    echo "<TR><TD BACKGROUND=''>";

    echo "<FONT FACE='Georgia,Garamond,Times,serif' SIZE=3>";

    echo "\n<p align='justify'>Vous pouvez importer une liste d'auteurs &agrave; partir d'un fichier au format .CSV (Comma Separted Value). Ce type de fichier peut-&ecirc;tre obtenu &agrave; partir d'un fichier de type Excel. Consultez la documentation de votre tableur pour savoir comment enregistrer dans se format. Un conseil, fates une sauvegarde de votre base de donnes avant toutes choses. <b>Vous devez ensuite placer le fichier liste_auteurs.csv qui vous aurez cr dans le rpertoire /ecrire/data/</b> <br><br>Pour crer la liste  partir du fichier liste_auteurs.csv, <A HREF=\"?exec=auteurs_import&action=importcsv\">cliquez ici</A>";
    
    echo "</FONT>";
    echo "</TD></TR>";
    echo "</TABLE>";
    
    fin_cadre_relief();

if ($_GET['action'] == "importcsv") {

    // fichier a convertir
    $nom_fichier = "data/liste_auteurs.csv";

    // caractere de separation
    $separateur=";";

    if (!file_exists($nom_fichier)) {
        echo  "<br><span style='color: red; font-weight: bold;'>Fichier introuvable</span><br>";
    }
    else {
        
        $fp = fopen($nom_fichier,  "r");
        
				//  fonction qui enlve les accents
				$Caracs = array("" => "Y", "" => "u", "" => "A", "" => "A",
                "" => "A", "" => "A", "" => "A", "" => "A",
                "" => "A", "" => "C", "" => "E", "" => "E",
                "" => "E", "" => "E", "" => "I", "" => "I",
                "" => "I", "" => "I", "" => "D", "" => "N",
                "" => "O", "" => "O", "" => "O", "" => "O",
                "" => "O", "" => "O", "" => "U", "" => "U",
                "" => "U", "" => "U", "" => "Y", "" => "s",
                "" => "a", "" => "a", "" => "a", "" => "a",
                "" => "a", "" => "a", "" => "a", "" => "c",
                "" => "e", "" => "e", "" => "e", "" => "e",
                "" => "i", "" => "i", "" => "i", "" => "i",
                "" => "o", "" => "n", "" => "o", "" => "o",
                "" => "o", "" => "o", "" => "o", "" => "o",
                "" => "u", "" => "u", "" => "u", "" => "u",
                "" => "y", "" => "y");
				
				// fonction qui gnre un mot de passe
				function MDP() {
                    
                    $chrs = 8;
                    $pwd = ""  ;

                    mt_srand ((double) microtime() * 1000000);
                    
                    while (strlen($pwd)<$chrs) {
                     $chr = chr(mt_rand (0,255));
                     if (eregi("^[a-hj-km-np-z2-9]$", $chr))
                     $pwd = $pwd.$chr;
                    }
                    
                    return strtolower($pwd);
				}
				
        echo "<BR><BR><TABLE BORDER=1 CELLSPACING=1 CELLPADDING=8 WIDTH=\"100%\" BORDERCOLOR=\"#000\">";

        // parcours du fichier
        while (!feof($fp)) {
            
            $ligne = fgets($fp,4096);  // On se dplace d'une ligne
            $liste = explode($separateur,$ligne);  // Champs spars par ;

            // les valeur du fichier
            $nom = $liste[0];
            $bio = $liste[1];
            $email = $liste[2];
            $nom_site = $liste[3];
            $url_site = $liste[4];
            $pgp = $liste[5];
            $type_acces = $liste[6];
                
            $nom = trim($nom);

            if (!empty($nom)) {
                
                // login  partir du nom sans caractre spciaux
                $login = strip_tags($nom);
                $login  = strtr($login, $Caracs); 
                $login  = eregi_replace("[^a-z0-9]", "", $login); 
                $login = strtolower($login);
                // limitation de la taille du login
                if (strlen($login) > 10) { $login = substr($login, 0, 10); }

                // verifier si le login est deja pris 
			    $n = spip_fetch_array(spip_query("SELECT COUNT(*) AS n FROM spip_auteurs WHERE login='".$login."' AND statut!='5poubelle'"));
			    if ($n['n']) {
                    // un recap  l'cran
                    echo "<TR>";		
                    echo "<TD>".$nom."</TD>";
                    echo "<TD colspan='7'>Deja enregistre</TD>";
                    echo "</TR>"; 
                } else {
                        
                    $nom = addslashes($nom);
                    $bio = addslashes($bio);
                    $nom_site = addslashes($nom_site);
                    $url_site = addslashes($url_site);
                        
                    // mot de passe gnr
                    $new_pass = MDP();
                        
                    // les trucs de spip ;)		
                    $htpass = generer_htpass($new_pass);
                    $alea_actuel = creer_uniqid();
                    $alea_futur = creer_uniqid();
                    $pass = md5($alea_actuel.$new_pass);
                    
                    // un recap  l'cran
                    echo "<TR>";		
                    echo "<TD>".$nom."</TD>";
                    if (!empty($bio)) { echo "<TD>".$bio."</TD>"; } else { echo "<TD>&nbsp;</TD>"; }
                    if (!empty($email)) { echo "<TD>".$email."</TD>"; } else { echo "<TD>&nbsp;</TD>"; } 
                    if (!empty($nom_site)) { echo "<TD>".$nom_site."</TD>"; } else { echo "<TD>&nbsp;</TD>"; } 
                    if (!empty($url_site)) { echo "<TD>".$url_site."</TD>"; } else { echo "<TD>&nbsp;</TD>"; } 
                    if (!empty($pgp)) { echo "<TD>".$pgp."</TD>"; } else { echo "<TD>&nbsp;</TD>"; } 
                    if (!empty($login)) { echo "<TD>".$login."</TD>"; } else { echo "<TD>&nbsp;</TD>"; } 
                    if (!empty($new_pass)) { echo "<TD>".$new_pass."</TD>"; } else { echo "<TD>&nbsp;</TD>"; }
                    echo "</TR>"; 
                    
                            // insertion dans la base
                        $query = "INSERT INTO spip_auteurs (nom,login,bio,email,nom_site,url_site,pgp,statut,pass,htpass,alea_actuel,alea_futur) VALUES
                            ('$nom',
                            '$login',
                            '$bio',
                            '$email',
                            '$nom_site',
                            '$url_site',
                            '$pgp',
                            '$type_acces',
                            '$pass',
                            '$htpass',
                            '$alea_actuel',
                            '$alea_futur')";
                        spip_query($query) OR die($query);
                }


            }
            
        }
        fclose($fp);
    
        echo "</TABLE>";
    }

}			 

fin_page();

}

?>


